<?php
/**
 * Эта модель предназначена для работы с временными ссылками на файлы
 *
 * @link http://www.simplecoding.org
 * @author Стаценко Владимир <vova_33@gala.net>
 */
class MFileLink extends Model {

	function MFileLink() {
		parent::Model();
	}
	
	/**
	 * Создает временную ссылку и добавляет ее в базу
	 *
	 * @param $fileName - имя файла
	 * @return ссылку, если она создана, false - если возникла ошибка
	 */
	function createLink($fileName) {
		$userIP = $_SERVER['REMOTE_ADDR'];
		$fileLink = md5($userIP.time());
		
		//проверяем существование файла
		if (!get_file_info($this->config->item('filesdir').'/'.$fileName)) {
			return false;
		}

		$qCreateLink = 'INSERT INTO file_downloads (ip, fileLink, expired, fileName)'
			.' VALUES (?, ?, NOW() + INTERVAL '.$this->config->item('linktime').' SECOND, ?)';
		if ($this->db->query($qCreateLink,
			array(
				$userIP,
				$fileLink,
				$fileName
		))) {
			return $fileLink;
		}
		else {
			return false;
		}
	}
	
	/**
	 * Проверяет временную ссылку
	 *
	 * @param $link - временная ссылка на файл
	 * @return имя файла - если ссылка рабочая, false - если нет.
	 */
	function checkFileLink($link) {
		$userIP = $_SERVER['REMOTE_ADDR'];
		
		$qCheckLink = 'SELECT fileName FROM file_downloads WHERE ip=? AND fileLink=? AND (expired >= NOW())';
		$res = $this->db->query($qCheckLink, array($userIP, $link));
		
		if ($res->num_rows() == 1) {
			$r = $res->result_array();
			return $r[0]['fileName'];
		}
		else {
			return false;
		}
	}
}
?>